	list p=16F84A

; PIC16F84 mit 4 Mhz Takt

	#include <P16F84A.INC>
	
; Configuration festlegen:
; Power on Timer, kein Watchdog, XT-Oscillator
	
		__CONFIG	_PWRTE_ON & _WDT_OFF & _XT_OSC

; Variablen festlegen
loop		equ	0x13
loops		equ	0x14
loops2		equ	0x15
letter		equ	0x16
lcount		equ	0x17
dsend		equ	0x18
dcount		equ	0x19
rowcount	equ	0x1A
rock		equ	0x1B
letc		equ 0x1C


; Konstanten festlegen
#define CLK		PORTB,6		;Clock fr das Schieberegister
#define DATA	PORTB,5		;Serielle Datenausgabe
#define STROBE	PORTB,4		;Daten auf die Ausgnge durchschalten
#define OE		PORTB,7		;Output Enable


; ************* Initalisierung **********************************

Init	bsf     STATUS, RP0		; auf Bank 1 umschalten
		movlw	B'00000000'		; 0 ins w, dann nach TRISB & TRISA, PORTB & PORTA alle Output
		movwf	TRISB
		movwf	TRISA
		bcf     STATUS, RP0		; auf Bank 0 zurckschalten
		movlw	.0
		movwf	PORTB			; alle Ports auf LOW
		movwf	PORTA
		clrf	loop			; alle Variablen clear
		clrf	loops
		clrf	loops2
		clrf	letter
		clrf	lcount
		clrf	dsend
		clrf	dcount
		clrf	rowcount
		clrf	rock
		clrf	letc

; ************ Hauptprogramm ************************************
main
		movlw	.8
		movwf	rowcount
		call	zerobits
maybe1
		movlw	.8
		movwf	letc		;Buchstabencounter
		movwf	lcount		;Zhler fr 8 Ziffern
		bcf		STROBE		;Clear Strobe fr saubere Anzeige
		call	row			;Zeile festlegen

		call	lowled3
maybe2
		call	letc_read	;Buchstabe auslesen
		movwf	letter
		call	table_read
		clrf	PCLATH
		movwf	dsend
		call	data_send
		call	next_letter
		
		decfsz	lcount,f
		goto	maybe2		
		call	lowled4
		bsf		STROBE
		nop
		nop
		bcf		STROBE
		call	next_row
		goto	maybe1
		
;zerobits ******************************************************
zerobits
		movlw	.0
		movwf	dsend
		movlw	.81
		movwf	dcount
		bcf		DATA
		
		call	data_loop
		
		bsf		STROBE
		bsf		OE
		call	Wait
		bcf		STROBE
		call	Wait
		
		return
;zerobits *******************************************************

;letc_read ******************************************************
letc_read

	;EEPROM Daten auslesen
		bcf		STATUS, RP0	;Bank0 zurck schalten
		movf	letc, w		;EEPROM-Zelle die ausgelesen werden soll
		movwf	EEADR		;Adressvariable
		bsf		STATUS, RP0	;Bank1 umschalten
		bsf		EECON1, RD	;auslesen
		bcf		STATUS, RP0	;Bank0 zurck schalten
		movf	EEDATA, w	;Daten in W kopieren
		
		return
;letc_read ******************************************************

;row ************************************************************
row
		movf	rowcount,w
		call	rowpcl
		btfsc	rock,1
		goto	rowreturn
		movwf	dsend
		call	data_send
		bsf		CLK
		nop
		nop
		bcf		CLK
		nop
		nop
		bsf		CLK
		nop
		nop
		bcf		CLK
rowreturn
		clrf	rock
		return
;row ************************************************************

;rowpcl *********************************************************
rowpcl
		addwf	PCL, f
		retlw	.1			;Zeile9
		retlw	.2			;Zeile8
		retlw	.4			;Zeile7
		retlw	.8			;Zeile6
		retlw	.16			;Zeile5
		retlw	.32			;Zeile4
		retlw	.64			;Zeile3
		goto	row2		;Zeile2
		call	row1		;Zeile1
rowpclend
		return
;rowpcl *********************************************************

;row1 ***********************************************************
row1
		movlw	.0
		movwf	dsend
		call	data_send
		bsf		CLK
		nop
		nop
		bcf		CLK
		nop
		bsf		DATA
		nop
		bsf		CLK
		nop
		nop
		bcf		CLK
		movlw	.255
		movwf	rock
		bcf		DATA
		return
;row1 ************************************************************

;row2 ***********************************************************
row2
		movlw	.0
		movwf	dsend
		call	data_send
		bsf		CLK
		nop
		nop
		bcf		CLK
		nop
		bsf		DATA
		nop
		bsf		CLK
		nop
		nop
		bcf		CLK
		nop
		bcf		DATA
		nop
		bsf		CLK
		nop
		nop
		bcf		CLK
		movlw	.255
		movwf	rock
		goto rowpclend
;row2 ************************************************************

;lowled3 *********************************************************
lowled3
		
		movlw	.0
		movwf	dsend
		movlw	.3
		movwf	dcount
		bcf		DATA
		
		call	data_loop
		
		return
;lowled3 ********************************************************

;lowled4 *********************************************************
lowled4
		
		movlw	.0
		movwf	dsend
		movlw	.4
		movwf	dcount
		bcf		DATA
		
		call	data_loop
		
		return
;lowled4 ********************************************************

;table_read *****************************************************
table_read
		movf	rowcount,w
		call	table_row
		
		addwf	PCL, f
		movlw	0x02
		movwf	PCLATH
		call	Zeile9
		return
		movlw	0x02
		movwf	PCLATH
		call	Zeile8
		return
		movlw	0x02
		movwf	PCLATH
		call	Zeile7
		return
		movlw	0x02
		movwf	PCLATH
		call	Zeile6
		return
		movlw	0x01
		movwf	PCLATH
		call	Zeile5
		return
		movlw	0x01
		movwf	PCLATH
		call	Zeile4
		return
		movlw	0x01
		movwf	PCLATH
		call	Zeile3
		return
		movlw	0x01
		movwf	PCLATH
		call	Zeile2
		return
		movlw	0x01
		movwf	PCLATH
		call	Zeile1
		return
;table_read *****************************************************

;table_row ******************************************************
table_row
		addwf	PCL, f
		retlw	.0		;Zeile9
		retlw	.4		;Zeile8
		retlw	.8		;Zeile7
		retlw	.12		;Zeile6
		retlw	.16		;Zeile5
		retlw	.20		;Zeile4
		retlw	.24		;Zeile3
		retlw	.28		;Zeile2
		retlw	.32		;Zeile1
;table_row ******************************************************

;next_row *******************************************************
next_row
		incf	rowcount,f
		decfsz	rowcount,f
		goto	rback
		movlw	.8
		movwf	rowcount
		goto	rnull
rback	decf	rowcount,f
rnull	return
;next_row *******************************************************

;next_letter ****************************************************
next_letter
		decfsz	letc,f
		goto	lback
		movlw	.8
		movwf	letc
lback	return
;next_letter ****************************************************
		
; ************ Daten ausgeben an Schieberegister ****************

data_send

		movlw	.8
		movwf	dcount
		bcf		DATA
data_loop
		bsf		CLK
		btfss	dsend,8
		goto	d_next1
		bsf		DATA
		goto	d_next2
d_next1	bcf		DATA
d_next2	nop
		bcf		CLK
		
		rrf		dsend,f
		decfsz	dcount,f
		goto	data_loop
		bcf		DATA

		return

; ************ Warteschleifen ***********************************
		
; Zeitkonstante fr 1ms
	
Wait
		movlw	.110
		movwf	loops2	
Wait2
		nop
		nop
		nop
		nop
		nop
		nop
		decfsz	loops2, F	;1ms vorbei?
		goto	Wait2		;nein, noch nicht
		return				;Ende mit 1ms
		
; ENDE der Warteschleifen ***************************************

; Beginn der Tabelle fr Grobuchstaben *************************
	org 0x00FF
Zeile1

		movf	letter,w
		
	addwf PCL, f
	retlw B'00000000'	;Leerzeichen
	retlw B'00001100'	;A
	retlw B'00111110'	;B
	retlw B'00001100'	;C
	retlw B'00111100'	;D
	retlw B'00111111'	;E
	retlw B'00111111'	;F
	retlw B'00001100'	;G
	retlw B'00110011'	;H
	retlw B'00001100'	;I
	retlw B'00111111'	;J
	retlw B'00110011'	;K
	retlw B'00110000'	;L
	retlw B'01110111'	;M
	retlw B'00110011'	;N
	retlw B'00001100'	;O
	retlw B'00111110'	;P
	retlw B'00001100'	;Q
	retlw B'00111100'	;R
	retlw B'00001100'	;S
	retlw B'00111111'	;T
	retlw B'00110011'	;U
	retlw B'00110011'	;V
	retlw B'01100011'	;W
	retlw B'00110011'	;X
	retlw B'00110011'	;Y
	retlw B'00111111'	;Z
	retlw B'00110011'	;
	retlw B'00110011'	;
	retlw B'00110011'	;

	org 0x011F
Zeile2

		movf	letter,w

	addwf PCL, f
	retlw B'00000000'	;Leerzeichen
	retlw B'00011110'	;A
	retlw B'00111111'	;B
	retlw B'00011110'	;C
	retlw B'00111110'	;D
	retlw B'00111111'	;E
	retlw B'00111111'	;F
	retlw B'00011110'	;G
	retlw B'00110011'	;H
	retlw B'00001100'	;I
	retlw B'00111111'	;J
	retlw B'00110011'	;K
	retlw B'00110000'	;L
	retlw B'01111111'	;M
	retlw B'00111011'	;N
	retlw B'00011110'	;O
	retlw B'00111111'	;P
	retlw B'00011110'	;Q
	retlw B'00111110'	;R
	retlw B'00011110'	;S
	retlw B'00111111'	;T
	retlw B'00110011'	;U
	retlw B'00110011'	;V
	retlw B'01100011'	;W
	retlw B'00110011'	;X
	retlw B'00110011'	;Y
	retlw B'00111111'	;Z
	retlw B'00001100'	;
	retlw B'00000000'	;
	retlw B'00001100'	;

	org	0x013F
Zeile3

		movf	letter,w

	addwf PCL, f
	retlw B'00000000'	;Leerzeichen
	retlw B'00110011'	;A
	retlw B'00110011'	;B
	retlw B'00110011'	;C
	retlw B'00110011'	;D
	retlw B'00110000'	;E
	retlw B'00110000'	;F
	retlw B'00011110'	;G
	retlw B'00110011'	;H
	retlw B'00001100'	;I
	retlw B'00000011'	;J
	retlw B'00110011'	;K
	retlw B'00110000'	;L
	retlw B'01101011'	;M
	retlw B'00111011'	;N
	retlw B'00110011'	;O
	retlw B'00110011'	;P
	retlw B'00110011'	;Q
	retlw B'00110011'	;R
	retlw B'00110011'	;S
	retlw B'00001100'	;T
	retlw B'00110011'	;U
	retlw B'00110011'	;V
	retlw B'01100011'	;W
	retlw B'00110011'	;X
	retlw B'00110011'	;Y
	retlw B'00000011'	;Z
	retlw B'00011110'	;
	retlw B'00110011'	;
	retlw B'00011110'	;

	org	0x015F
Zeile4

		movf	letter,w

	addwf PCL, f
	retlw B'00000000'	;Leerzeichen
	retlw B'00110011'	;A
	retlw B'00110011'	;B
	retlw B'00110000'	;C
	retlw B'00110011'	;D
	retlw B'00110000'	;E
	retlw B'00110000'	;F
	retlw B'00110000'	;G
	retlw B'00111111'	;H
	retlw B'00001100'	;I
	retlw B'00000011'	;J
	retlw B'00110110'	;K
	retlw B'00110000'	;L
	retlw B'01100011'	;M
	retlw B'00111011'	;N
	retlw B'00110011'	;O
	retlw B'00110011'	;P
	retlw B'00110011'	;Q
	retlw B'00110011'	;R
	retlw B'00110000'	;S
	retlw B'00001100'	;T
	retlw B'00110011'	;U
	retlw B'00110011'	;V
	retlw B'01101011'	;W
	retlw B'00011110'	;X
	retlw B'00110011'	;Y
	retlw B'00000110'	;Z
	retlw B'00110011'	;
	retlw B'00110011'	;
	retlw B'00110011'	;

	org	0x017F
Zeile5

		movf	letter,w

	addwf PCL, f
	retlw B'00000000'	;Leerzeichen
	retlw B'00111111'	;A
	retlw B'00111110'	;B
	retlw B'00110000'	;C
	retlw B'00110011'	;D
	retlw B'00111110'	;E
	retlw B'00111110'	;F
	retlw B'00110111'	;G
	retlw B'00111111'	;H
	retlw B'00001100'	;I
	retlw B'00000011'	;J
	retlw B'00111100'	;K
	retlw B'00110000'	;L
	retlw B'01100011'	;M
	retlw B'00111111'	;N
	retlw B'00110011'	;O
	retlw B'00111111'	;P
	retlw B'00110011'	;Q
	retlw B'00111110'	;R
	retlw B'00011110'	;S
	retlw B'00001100'	;T
	retlw B'00110011'	;U
	retlw B'00110011'	;V
	retlw B'01101011'	;W
	retlw B'00001100'	;X
	retlw B'00011110'	;Y
	retlw B'00001100'	;Z
	retlw B'00110011'	;
	retlw B'00110011'	;
	retlw B'00110011'	;

	org	0x01FF
Zeile6

		movf	letter,w

	addwf PCL, f
	retlw B'00000000'	;Leerzeichen
	retlw B'00111111'	;A
	retlw B'00110011'	;B
	retlw B'00110000'	;C
	retlw B'00110011'	;D
	retlw B'00110000'	;E
	retlw B'00111110'	;F
	retlw B'00110011'	;G
	retlw B'00110011'	;H
	retlw B'00001100'	;I
	retlw B'00000011'	;J
	retlw B'00110110'	;K
	retlw B'00110000'	;L
	retlw B'01100011'	;M
	retlw B'00110111'	;N
	retlw B'00110011'	;O
	retlw B'00111110'	;P
	retlw B'00110011'	;Q
	retlw B'00111100'	;R
	retlw B'00000011'	;S
	retlw B'00001100'	;T
	retlw B'00110011'	;U
	retlw B'00010010'	;V
	retlw B'01101011'	;W
	retlw B'00011110'	;X
	retlw B'00001100'	;Y
	retlw B'00011000'	;Z
	retlw B'00111111'	;
	retlw B'00110011'	;
	retlw B'00110011'	;

	org	0x021F
Zeile7

		movf	letter,w

	addwf PCL, f
	retlw B'00000000'	;Leerzeichen
	retlw B'00110011'	;A
	retlw B'00110011'	;B
	retlw B'00110011'	;C
	retlw B'00110011'	;D
	retlw B'00110000'	;E
	retlw B'00110000'	;F
	retlw B'00110011'	;G
	retlw B'00110011'	;H
	retlw B'00001100'	;I
	retlw B'00110011'	;J
	retlw B'00110011'	;K
	retlw B'00110000'	;L
	retlw B'01100011'	;M
	retlw B'00110111'	;N
	retlw B'00110011'	;O
	retlw B'00110000'	;P
	retlw B'00110111'	;Q
	retlw B'00110110'	;R
	retlw B'00110011'	;S
	retlw B'00001100'	;T
	retlw B'00110011'	;U
	retlw B'00010010'	;V
	retlw B'00011110'	;W
	retlw B'00110011'	;X
	retlw B'00001100'	;Y
	retlw B'00110000'	;Z
	retlw B'00111111'	;
	retlw B'00110011'	;
	retlw B'00110011'	;

	org	0x023F
Zeile8

		movf	letter,w

	addwf PCL, f
	retlw B'00000000'	;Leerzeichen
	retlw B'00110011'	;A
	retlw B'00111111'	;B
	retlw B'00011110'	;C
	retlw B'00111110'	;D
	retlw B'00111111'	;E
	retlw B'00110000'	;F
	retlw B'00011110'	;G
	retlw B'00110011'	;H
	retlw B'00001100'	;I
	retlw B'00011110'	;J
	retlw B'00110011'	;K
	retlw B'00111111'	;L
	retlw B'01100011'	;M
	retlw B'00110011'	;N
	retlw B'00011110'	;O
	retlw B'00110000'	;P
	retlw B'00011110'	;Q
	retlw B'00110011'	;R
	retlw B'00011110'	;S
	retlw B'00001100'	;T
	retlw B'00011110'	;U
	retlw B'00011110'	;V
	retlw B'00110110'	;W
	retlw B'00110011'	;X
	retlw B'00001100'	;Y
	retlw B'00111111'	;Z
	retlw B'00110011'	;
	retlw B'00011110'	;
	retlw B'00011110'	;
	retlw B'00111100'	;

	org 0x0262
Zeile9

		movf	letter,w

	addwf PCL, f
	retlw B'00000000'	;Leerzeichen
	retlw B'00110011'	;A
	retlw B'00111110'	;B
	retlw B'00001100'	;C
	retlw B'00111100'	;D
	retlw B'00111111'	;E
	retlw B'00110000'	;F
	retlw B'00001100'	;G
	retlw B'00110011'	;H
	retlw B'00001100'	;I
	retlw B'00001100'	;J
	retlw B'00110011'	;K
	retlw B'00111111'	;L
	retlw B'01100011'	;M
	retlw B'00110011'	;N
	retlw B'00001100'	;O
	retlw B'00110000'	;P
	retlw B'00001101'	;Q
	retlw B'00110011'	;R
	retlw B'00001100'	;S
	retlw B'00001100'	;T
	retlw B'00001100'	;U
	retlw B'00001100'	;V
	retlw B'00010100'	;W
	retlw B'00110011'	;X
	retlw B'00001100'	;Y
	retlw B'00111111'	;Z
	retlw B'00110011'	;
	retlw B'00001100'	;
	retlw B'00001100'	;
	
; Ende der Tabelle fr Grobuchstaben ***************************

	
	;Daten ab der EEPROM-Zelle 00h
		org		H'2100'		;Platz im EEPROM-Speicher fr Brenner
		de		.0			;Bitplatzhalter
		de		.14			;Buchstabe1: N
		de		.15			;Buchstabe2: O
		de		.0			;Buchstabe3:  
		de		.5			;Buchstabe4: E
		de		.18			;Buchstabe5: R
		de		.18			;Buchstabe6: R
		de		.15			;Buchstabe7: O
		de		.18			;Buchstabe8: R



		end